﻿Type=Class
Version=2.5
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private Parser As SaxParser
	Private Title, link, PubDate, Description,img As String
	Private Html1 As Html
	Private itemnumber As Int
	Private pi As pageinfo
	Private Thread1 As Thread
	Private exp As ExceptionEx
	Private itemlist As List
	Private tt As Timer
	Private ttnum
	Private fn As String
	Private pagenum As Int
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(num As Int,p As pageinfo)
	
	Parser.Initialize
	itemlist.Initialize
	tt.Initialize("tt",2000)
	
  pagenum=num
	itemnumber=0
	pi=p
	ttnum=0
	
	exp.Initialize("stop Parser")
	Thread1.Initialise("Thread1")
	Thread1.Start(Me,"ParserXml", Null)	
	tt.Enabled=True
End Sub

Sub tt_Tick
	If itemnumber>ttnum Then
	  ttnum=itemnumber
	Else If itemnumber>0 Then
		tt.Enabled=False
		Thread1.RunOnGuiThread("updaterss",Null)
	End If	
	  
End Sub

Sub ParserXml
  Dim textin As TextReader
	Try
		textin.Initialize2(pi.In,pi.incoding)
		Parser.Parse2(textin, "Parser")
	Catch
		tt.Enabled=False
		Thread1.RunOnGuiThread("updaterss",Null)
	End Try
	
	textin.Close
End Sub

Sub Thread1_Ended(fail As Boolean, error As String) 'An error or Exception has occurred in the Thread

End Sub

Sub Parser_StartElement(Uri As String, Name As String, a As Attributes)
'  Log("Uri=" & Uri & CRLF & "Name=" & Name & CRLF & "Attrib=" & a.GetValue(2))
	If itemnumber>500 Then
		exp.Throw
	End If
End Sub

Sub Parser_EndElement(Uri As String, Name As String, Text As StringBuilder)
	Dim s,s1(),s2(),s3() As String
	Dim t As Long
	
	' end reading file
	If Name.trim.ToLowerCase = "rss" Then
		tt.Enabled=False
		Thread1.RunOnGuiThread("updaterss",Null)
	End If
	
	If Parser.Parents.IndexOf("item") > -1 Then
		If Name = "title" Then
			Title = Text.ToString.trim
		Else If Name = "link" Then
			link = Text.ToString.trim
		Else If Name = "pubDate" Then
			PubDate = Text.ToString.trim
		Else If Name = "description" Then
			Description = Text.ToString.trim
		Else If Name = "img" Then
			img = Text.ToString.trim
			Log(img)
		End If
	End If

	If Name = "item" Then
		Dim it As linkitem
	  it.Description=Description
		it.link=link
		it.linkname=pi.linkname
		it.PubDate=PubDate
		it.Title=Title
		it.t=PubDateToDate(PubDate)
		itemlist.Add(it)
	
	'first item in file
		If itemnumber=0 Then
			pi.lastupdate=PubDate
			pi.t=t
		End If
		itemnumber=itemnumber+1
'		Log(pi.linkname&" "&itemnumber)

		Title = ""
		link = ""
		PubDate = ""
		Description = ""
		img=""
	End If
End Sub

Sub updaterss
  CallSub3(Main,"updaterss",itemlist,pagenum)
End Sub

Sub PubDateToDate(sdate As String) As Long
	Dim s,s1(),s2(),s3() As String
	Dim t As Long
	
	If sdate="" Then Return 0
	
	t=0
	DateTime.DateFormat="MM/dd/yyyy"
	
	'Log(sdate)
	s1= Regex.Split(" ", sdate)
	Try
		' 2013-01-25T21:49:43.0
		If s1.Length=1 Then
			s1=Regex.Split("T", sdate)
			s2=Regex.Split("-",s1(0))
			s=s2(1)&"/"&s2(2)&"/"&s2(0)
'			s3=Regex.Split(".",s1(1))
			t = DateTime.DateTimeParse(s,s1(1))
		'
		Else If s1.Length=2 Then
			s2=Regex.Split("/", s1(0))
			s=s2(1)&"/"&s2(0)&"/"&s2(2)
			t = DateTime.DateTimeParse(s,s1(1))
		Else If s1.Length>2 Then
				'Mon, 09 Jul 2012 14:34:24 GMT
			If sdate.Contains(",") Then
				s1= Regex.Split(",", sdate)
				s1= Regex.Split(" ", s1(1).Trim)
				' בדיקת פורמט שעה
				s3=Regex.Split(":", s1(3).Trim)
				If s3.Length=2 Then s1(3)=s1(3)&":00"
			
				s=getmonth(s1(1))&"/"&s1(0)&"/"&s1(2)
				t = DateTime.DateTimeParse(s,s1(3)) 	
			Else
				'Fri Jan 25 22:43:00 IST 2013
				s=getmonth(s1(1))&"/"&s1(2)&"/"&s1(5)
				t = DateTime.DateTimeParse(s,s1(3)) 	
			End If	
		End If
	Catch	
	End Try
	
	Return t
End Sub

Sub getmonth(s As String)As Int
  Select Case s
	  Case "Jan":Return 1
		Case "Feb": Return 2
	  Case "Mar":Return 3
		Case "Apr":Return 4
	  Case "May":Return 5
		Case "Jun": Return 6
	  Case "Jul":Return 7
		Case "Aug": Return 8
	  Case "Sep":Return 9
		Case "Oct": Return 10
	  Case "Nov":Return 11
		Case "Dec":Return 12
	End Select
	Return 1
End Sub

